#include<bits/stdc++.h>
using namespace std;

int N,M,K,boja=0;
int a[10005][10005]={0};

void print()
{
    for(int i=1;i<=N;i++)
    {
        for(int j=1;j<=M;j++)
        {
            cout << a[i][j] << " ";
            if(j==M)cout << "\n";
        }
    }
}

int dfs(int x, int y, int boja)
{
    if(x<=0 || y<=0 || y>M || x>N || a[x][y]!=0)return 0;
    a[x][y]=boja;
    dfs(x+1,y,boja);
    dfs(x-1,y,boja);
    dfs(x,y+1,boja);
    dfs(x,y-1,boja);

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> M >> K;

    while(K--)
    {
        int l,d;
        cin >> l >> d;
        a[l][d]=-1;
    }

    //print();

    for(int i=1;i<=N;i++)
    {
        for(int j=1;j<=M;j++)
        {
            if(a[i][j]==0)dfs(i,j,boja++);
        }
    }

    //print();

    cout << boja;
    return 0;

}